﻿# -*- coding: utf-8 -*-
#*******************************************************************************
#**  This file is part of HgWeb Manager.                                     ***
#**                                                                          ***
#**  Copyright (C) 2014                                                      ***
#**  CodeGNU Solutions <Licensing _AT_ CodeGNU _DOT_ com>                    ***
#**                                                                          ***
#**  This program is free software: you can redistribute it and/or modify it ***
#**  under the terms of the GNU Affero General Public License as published   ***
#**  by the Free Software Foundation, either version 3 of the License, or    ***
#**  (at your option) any later version.                                     ***
#**                                                                          ***
#**  This program is distributed in the hope that it will be useful, but     ***
#**  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
#**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
#**  See the GNU Affero General Public License for more details.             ***
#**                                                                          ***
#**  You should have received a copy of the GNU Affero General Public License***
#**  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
#*******************************************************************************

"""
 IMPORTS
"""
from ConfigParser import SafeConfigParser


class Manager(object):
	""" Manages the configurations for HgWebManager """
	# The configuration file parser.
	__parser = None
	# The path and file name of the hg command.
	HgCommand = None
	# The base directory path for the HgWeb repositories.
	RepositoryPath = None
	# The base directory path to the HgWeb web-server.
	HgWebPath = None
	# The user-name of the Mercurial web-manager.
	HgUser = None

	def __init__(self, path = ['/etc/hwm.ini', '~/.hwm/hwm.ini', './hwm.ini']):
		""" Loads the settings values stored in the configuration file.

			@param[in] path	The path and file name of the configuration file.
		"""
		self.__parser = SafeConfigParser()
		self.__parser.read(path)

		if self.__parser.has_section('Mercurial'):
			if self.__parser.has_option('Mercurial', 'Base'):
				self.RepositoryPath = self.__parser.get('Mercurial', 'Base')

			if self.__parser.has_option('Mercurial', 'Command'):
				self.HgCommand = self.__parser.get('Mercurial', 'Command')

			if self.__parser.has_option('Mercurial', 'User'):
				self.HgUser = self.__parser.get('Mercurial', 'User')

			if self.__parser.has_option('Mercurial', 'Web'):
				self.HgWebPath = self.__parser.get('Mercurial', 'Web')
		else:
			self.HgUser = "hg"
			self.RepositoryPath = "/var/hg/repos"
			self.HgCommand = "/usr/bin/hg"
			self.HgWebPath = "/var/www/hgweb"
